/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.MapLoginUserToPegawaiDto;
import com.portofolio.service.MapLoginUserToPegawaiService;
import com.portofolio.util.RestUtil;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/mapLoginUserToPegawai")
public class MapLoginUserToPegawaiController extends LocaleController {
	@Lazy
	@Autowired
	private MapLoginUserToPegawaiService mapLoginUserToPegawaiService;

	
	
	@PutMapping("/update/{version}")
	public ResponseEntity<Map<String, Object>> update(	@Valid @RequestBody MapLoginUserToPegawaiDto entity, HttpServletRequest request) {
		Map<String, Object> result = mapLoginUserToPegawaiService.update(entity);
		return RestUtil.getJsonResponse(result);
	}


	
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> grid(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = "10") Integer rows,
			@RequestParam(value = "dir", defaultValue = "id.kdUser") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "kdUser", required = false) Long kdUser) {
		Map<String, Object> result = mapLoginUserToPegawaiService.grid(page, rows, sort, dir, kdUser);
		return RestUtil.getJsonResponse(result);
	}

	
	@GetMapping("/findByKode/{kdUser}")
	public ResponseEntity<Map<String, Object>> findByKode(@PathVariable("kdUser") Long kdUser, HttpServletRequest request) {
		Map<String, Object> result = mapLoginUserToPegawaiService.findByKode(kdUser);
		return RestUtil.getJsonResponse(result);
	}

}
